package javax.swing;

import java.awt.event.KeyEvent;
import java.awt.AWTKeyStroke;

public class KeyStroke extends AWTKeyStroke
{
    private static final long serialVersionUID = -9060180771037902530L;
    
    private KeyStroke() {
    }
    
    private KeyStroke(char keyChar, int keyCode, int modifiers, boolean onKeyRelease) {
        super(keyChar, keyCode, modifiers, onKeyRelease);
    }
    
    public static KeyStroke getKeyStroke(char keyChar) {
        synchronized (AWTKeyStroke.class) {
            AWTKeyStroke.registerSubclass(KeyStroke.class);
            return (KeyStroke)AWTKeyStroke.getAWTKeyStroke(keyChar);
        }
    }
    
    @Deprecated
    public static KeyStroke getKeyStroke(char c, boolean b) {
        return new KeyStroke(c, 0, 0, b);
    }
    
    public static KeyStroke getKeyStroke(Character keyChar, int modifiers) {
        synchronized (AWTKeyStroke.class) {
            AWTKeyStroke.registerSubclass(KeyStroke.class);
            return (KeyStroke)AWTKeyStroke.getAWTKeyStroke(keyChar, modifiers);
        }
    }
    
    public static KeyStroke getKeyStroke(int keyCode, int modifiers, boolean onKeyRelease) {
        synchronized (AWTKeyStroke.class) {
            AWTKeyStroke.registerSubclass(KeyStroke.class);
            return (KeyStroke)AWTKeyStroke.getAWTKeyStroke(keyCode, modifiers, onKeyRelease);
        }
    }
    
    public static KeyStroke getKeyStroke(int keyCode, int modifiers) {
        synchronized (AWTKeyStroke.class) {
            AWTKeyStroke.registerSubclass(KeyStroke.class);
            return (KeyStroke)AWTKeyStroke.getAWTKeyStroke(keyCode, modifiers);
        }
    }
    
    public static KeyStroke getKeyStrokeForEvent(KeyEvent anEvent) {
        synchronized (AWTKeyStroke.class) {
            AWTKeyStroke.registerSubclass(KeyStroke.class);
            return (KeyStroke)AWTKeyStroke.getAWTKeyStrokeForEvent(anEvent);
        }
    }
    
    public static KeyStroke getKeyStroke(String s) {
        if (s == null || s.length() == 0) {
            return null;
        }
        synchronized (AWTKeyStroke.class) {
            AWTKeyStroke.registerSubclass(KeyStroke.class);
            try {
                return (KeyStroke)AWTKeyStroke.getAWTKeyStroke(s);
            }
            catch (IllegalArgumentException ex) {
                return null;
            }
        }
    }
}
